#if (ARDUINO >= 100)
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif
#include <Ethernet.h>
  typedef enum
     {
        TEST1_SCALE_1         = 0b11,
        TEST1_SCALE_2         = 0b10,
        TEST1_SCALE_3         = 0b01,
        TEST1_SCALE_4         = 0b00
     } myenum;           
     
     struct Activ
     {
        bool isOver;
        bool isFree;
        bool isInacti;
        bool isActi;
        bool isPost;
     };  

class TEST1 
  {
  public:
    TEST1();
    
    //test return in  standard types
    
    //B4X 2 parameters byte => Wrapper => library Return void => wrapper => B4X    
    void testVoid(byte a, int16_t b);

    //B4X 2 parameters byte => Wrapper => library Return 1 bool parameter => wrapper => B4X bool       
    bool testAsupB(byte a, byte b);

    //B4X 2 parameters byte => Wrapper => char library Return 1 char parameter => wrapper => B4X byte     
    char testChar(char a, char b, bool c);

    //B4X 2 parameters byte => Wrapper => byte library Return 1 byte parameter => wrapper => B4X byte        
    byte testByteSumAB(byte a, byte b);

    //B4X 2 parameters int => Wrapper => int16_t library Return 1 int16_t parameter => wrapper => B4X int  
    int16_t testIntSumAB(int16_t a, int16_t b);

    //B4X 2 parameters uint => Wrapper => uint16_t library Return 1 uint16_t parameter => wrapper => B4X uint      
    uint16_t testUintSumAB(uint16_t a, uint16_t b);

    //B4X 2 parameters int => Wrapper => int32_t library Return 1 int32_t parameter => wrapper => B4X long      
    int32_t testLongSumAB(int32_t a, int32_t b);

    //B4X 2 parameters ulong => Wrapper => uint32_t library Return 1 uint32_t parameter => wrapper => B4X ulong      
    uint32_t testUlongSumAB(uint32_t a, uint32_t b);
                      
    //B4X 2 parameters double => Wrapper => float library Return 1 float parameter => wrapper => B4X double     
    float testFloatDivAbyB(float a, float b);

    //B4X 2 parameters double => Wrapper => double library Return 1 double parameter => wrapper => B4X double      
    double testDoubleDivAbyB(double a, double b);
    
    //test return in  Array types
    //B4X 2 parameters byte => Wrapper => byte library Return 1 byte* => wrapper => B4X ArrayByte*
    byte * testArrayByte(byte a, byte b);

    //B4X 2 parameters int => Wrapper => int16_t library Return 1 int16_t* => wrapper => B4X Arrayint*    
    int16_t * testArrayInt(int16_t a, int16_t b);

    //B4X 2 parameters uint16_t => Wrapper => uint16_t library Return 1 uint16_t* => wrapper => B4X ArrayUint*      
    uint16_t * testArrayUint(uint16_t a, uint16_t b);

    //B4X 2 parameters long => Wrapper => int32_t library Return 1 int32_t* => wrapper => B4X ArrayLong*          
    int32_t * testArrayLong(int32_t a, int32_t b);

    //B4X 2 parameters long => Wrapper => uint32_t library Return 1 uint32_t* => wrapper => B4X ArrayUlong*          
    uint32_t * testArrayUlong(uint32_t a, uint32_t b);

    //B4X 2 parameters Double => Wrapper => float library Return 1 float* => wrapper => B4X ArrayUDouble*       
    float * testArrayFloat(float a, float b);

    //B4X 2 parameters Double => Wrapper => double library Return 1 double* => wrapper => B4X ArrayUDouble*       
    double * testArrayDouble(double a, double b);
        
    //test return in  string types    
    //B4X 0 parameter => Wrapper => library Return 1 char* Array => wrapper => B4X B4RString     
    char * testB4RStringChar(void); 

    //B4X 2 B4Rstring => Wrapper => 2 char* library Return 1 char* Array => wrapper => B4X B4RString
    char * testB4RStringChar2(const char * a, const char * b); 

    //B4X 2 B4Rstring => Wrapper => 2 string library Return 1 string parameter => wrapper => B4X B4RString    
    String testB4RStringChar3(String a, String b); 

    //B4X 2 B4Rstring => Wrapper => 2 string library Return 1 char* Array => wrapper => B4X B4RString        
    char * testB4RStringChar4(String a, String b);

    //B4X 1 ArrayByte(IP) => Wrapper => 1 IPAddress library Return 1 IPAddress parameter => wrapper => B4X B4RString              
    IPAddress testIPAddress(IPAddress a);

    //B4X 1 ArrayByte => Wrapper => 1 byte* library Return 1 byte parameter => wrapper => B4X byte   
    byte testBytearray(byte* ab);

    //B4X 1 Arrayint => Wrapper => 1 int16_t* library Return 1 int16_t parameter => wrapper => B4X int       
    int16_t testintarray(int16_t* ab);
    
    //B4X 1 ArrayUint => Wrapper => 1 uint16_t* library Return 1 uint16_t parameter => wrapper => B4X uint       
    uint16_t testUintarray(uint16_t* ab);

    //B4X 1 Arraylong => Wrapper => 1 int32_t* library Return 1 int32_t parameter => wrapper => B4X long      
    int32_t testlongarray(int32_t* ab);

    //B4X 1 ArrayUlong => Wrapper => 1 uint32_t* library Return 1 uint32_t parameter => wrapper => B4X ulong      
    uint32_t testUlongarray(uint32_t* ab);

    //B4X 1 ArrayDouble => Wrapper => 1 float* library Return 1 float parameter => wrapper => B4X dpuble     
    float testfloatarray(float* ab);
                            
    //B4X 1 ArrayDouble => Wrapper => 1 double* library Return 1 double parameter => wrapper => B4X dpuble     
    double testDoublearray(double* ab);  

    // interrogation of size of arduino variables for this platforme    
    void testSizeOf();      
       
    // variables return in parameters
    void testreturndata(byte* ab, int16_t len, const char * as);
    
    // callback    
    void testcallback(char * topic, byte * payload, uint16_t length) ;
    
    // call processing to launch test of callback
    void processing();
     
    void SerialPrint(String txt);
    void SerialPrintln(String txt);
    
    void testsetenum(myenum a);
    
    void testsetstruct(Activ a);
    
    myenum testgetenum();
     
    Activ testgetstruct();
  };  