    //#New(backend):  Y                                               //- [Y]  if new (backend) to add
    //#Init_Base:     TEST1()                                               //- parameter to add at launch of library in case of backend
    //#Init_Include:                                                 //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:                                                  //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:   void testcallback(char * topic, byte * payload, uint16_t length)                                             //- callback on arduino side
    //#CallBack1_Config: SubVoid_StringBArray 0 1 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#include "B4RDefines.h"

namespace B4R
{

    B4RTEST1* B4RTEST1::instance = NULL;
    void B4RTEST1::Initialize(SubVoid_StringBArray MessageArrivedSub)
    {
       rcs = new (backend) TEST1();
       this->MessageArrivedSub = MessageArrivedSub; 
       instance = this;
    };

    void B4RTEST1::testcallback(char * topic, byte * payload, uint16_t length) 
    {
    const uint16_t cp = B4R::StackMemory::cp;
    B4RString* strtopic = CreateStackMemoryObject(B4RString);
    strtopic->data = topic;
    ArrayByte* arrpayload = CreateStackMemoryObject(ArrayByte);
    arrpayload->data = payload;
    arrpayload->length = length;
    instance->MessageArrivedSub(strtopic, arrpayload);
    B4R::StackMemory::cp = cp;
    };

//    TEST1()
    void B4RTEST1::testVoid(byte a, int16_t b)
    {
       rcs->testVoid(a, b);
    };

    bool B4RTEST1::testAsupB(byte a, byte b)
    {
       return rcs->testAsupB(a, b);
    };

    byte B4RTEST1::testChar(byte a, byte b, bool c)
    {
       return rcs->testChar(a, b, c);
    };

    byte B4RTEST1::testByteSumAB(byte a, byte b)
    {
       return rcs->testByteSumAB(a, b);
    };

    int16_t B4RTEST1::testIntSumAB(int16_t a, int16_t b)
    {
       return rcs->testIntSumAB(a, b);
    };

    uint16_t B4RTEST1::testUintSumAB(uint16_t a, uint16_t b)
    {
       return rcs->testUintSumAB(a, b);
    };

    int32_t B4RTEST1::testLongSumAB(int32_t a, int32_t b)
    {
       return rcs->testLongSumAB(a, b);
    };

    uint32_t B4RTEST1::testUlongSumAB(uint32_t a, uint32_t b)
    {
       return rcs->testUlongSumAB(a, b);
    };

    float B4RTEST1::testFloatDivAbyB(float a, float b)
    {
       return rcs->testFloatDivAbyB(a, b);
    };

    double B4RTEST1::testDoubleDivAbyB(double a, double b)
    {
       return rcs->testDoubleDivAbyB(a, b);
    };

    ArrayByte* B4RTEST1::testArrayByte(byte a, byte b)
    {
       byte* raw = rcs->testArrayByte(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayInt* B4RTEST1::testArrayInt(int16_t a, int16_t b)
    {
       int16_t* raw = rcs->testArrayInt(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayInt* arr = CreateStackMemoryObject(ArrayInt);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayUInt* B4RTEST1::testArrayUint(uint16_t a, uint16_t b)
    {
       uint16_t* raw = rcs->testArrayUint(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayUInt* arr = CreateStackMemoryObject(ArrayUInt);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayLong* B4RTEST1::testArrayLong(int32_t a, int32_t b)
    {
       int32_t* raw = rcs->testArrayLong(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayLong* arr = CreateStackMemoryObject(ArrayLong);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayULong* B4RTEST1::testArrayUlong(uint32_t a, uint32_t b)
    {
       uint32_t* raw = rcs->testArrayUlong(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayULong* arr = CreateStackMemoryObject(ArrayULong);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayDouble* B4RTEST1::testArrayFloat(float a, float b)
    {
       float* raw = rcs->testArrayFloat(a, b);
       uint16_t len = 2; //raw.size() or fixe value depending of the arduino part
       ArrayDouble* arr = CreateStackMemoryObject(ArrayDouble);
       arr->data=raw;
       arr->length=len;
       return arr;
    };

    ArrayDouble* B4RTEST1::testArrayDouble(double a, double b)
    {
       double* raw = rcs->testArrayDouble(a, b);
       union {byte array[4]; float arr; } Convert;
       uint16_t len = 3; //raw.size() or fixe value depending of the arduino part
       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);
       arr->data = (StackMemory::buffer + StackMemory::cp);
       for (uint16_t i = 0;i < len; i++) { 
         Convert.arr = raw[i];
         for (uint16_t j = 0; j < 4; j++) {
         StackMemory::buffer[StackMemory::cp++] =Convert.array[j];
         }
       }
       arr->length=len;
       return arr;
    };

    B4RString* B4RTEST1::testB4RStringChar()
    {
       char* raw = rcs->testB4RStringChar();
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    };

    B4RString* B4RTEST1::testB4RStringChar2(B4RString* a, B4RString* b)
    {
       char* raw = rcs->testB4RStringChar2(a->data, b->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    };

    B4RString* B4RTEST1::testB4RStringChar3(B4RString* a, B4RString* b)
    {
       String rax = rcs->testB4RStringChar3(a->data, b->data);
       PrintToMemory pm;
       B4RString* s = B4RString::PrintableToString(NULL);
       pm.print(rax);
       StackMemory::buffer[StackMemory::cp++] = 0;
       return s;
    };

    B4RString* B4RTEST1::testB4RStringChar4(B4RString* a, B4RString* b)
    {
       char* raw = rcs->testB4RStringChar4(a->data, b->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    };

    B4RString* B4RTEST1::testIPAddress(ArrayByte* a)
    {
       IPAddress ip = rcs->testIPAddress((Byte*)a->data);
       return B4RString::PrintableToString(&ip);
    };

    byte B4RTEST1::testBytearray(ArrayByte* ab)
    {
       return rcs->testBytearray((byte*)ab->data);
    };

    int16_t B4RTEST1::testintarray(ArrayInt* ab)
    {
       return rcs->testintarray((int16_t*)ab->data);
    };

    uint16_t B4RTEST1::testUintarray(ArrayUInt* ab)
    {
       return rcs->testUintarray((uint16_t*)ab->data);
    };

    int32_t B4RTEST1::testlongarray(ArrayLong* ab)
    {
       return rcs->testlongarray((int32_t*)ab->data);
    };

    uint32_t B4RTEST1::testUlongarray(ArrayULong* ab)
    {
       return rcs->testUlongarray((uint32_t*)ab->data);
    };

    float B4RTEST1::testfloatarray(ArrayDouble* ab)
    {
       return rcs->testfloatarray((float*)ab->data);
    };

    double B4RTEST1::testDoublearray(ArrayDouble* ab)
    {
      float * a = (float*)ab->data;  double b[ab->length];
      for (uint16_t x=0; x<(ab->length); x++) {b[x] = (double)a[x];};
      return rcs->testDoublearray(b);       
//       return rcs->testDoublearray((double*)a);
    };

    void B4RTEST1::testSizeOf()
    {
       rcs->testSizeOf();
    };

    void B4RTEST1::testreturndata(ArrayByte* ab, int16_t len, B4RString* as)
    {
       rcs->testreturndata((byte*)ab->data, len, as->data);
    };

//    void testcallback(char * topic, byte * payload, uint16_t length) 
    void B4RTEST1::processing()
    {
       rcs->processing();
    };

    byte B4RTEST1::testgetenum()
    {
      byte a = rcs->testgetenum();
       //  the cast from enum to byte is automatic
       return a;
    };
    
    byte B4RTEST1::testgetstruct()
    {
       byte raw = 0;
       Activ Active = rcs->testgetstruct();
       if (Active.isOver      ) {raw=raw | 0b0000000000010000;} ;
       if (Active.isFree      ) {raw=raw | 0b0000000000001000;} ;
       if (Active.isInacti    ) {raw=raw | 0b0000000000000100;} ;
       if (Active.isActi      ) {raw=raw | 0b0000000000000010;} ;
       if (Active.isPost      ) {raw=raw | 0b0000000000000001;} ;        
       return raw;
    };
    
    void B4RTEST1::testsetenum(byte a)
    {  myenum d; 
       switch(a) {
        case 3 : d = myenum::TEST1_SCALE_1 ;break;
        case 2 : d = myenum::TEST1_SCALE_2 ;break;
        case 1 : d = myenum::TEST1_SCALE_3 ;break;
        case 0 : d = myenum::TEST1_SCALE_4 ;break;
        default      : d = myenum::TEST1_SCALE_3;break;
       }
       rcs->testsetenum(d);
    }
    void B4RTEST1::testsetstruct(byte a)
    { Activ d = {false,false,false,false,false} ;
        if ((a & 1)>0) {d.isPost = true;}  ;
        if ((a & 2)>0) {d.isActi = true;}  ;
        if ((a & 4)>0) {d.isInacti = true;};
        if ((a & 8)>0) {d.isFree = true;}  ;
        if ((a & 16)>0) {d.isOver = true;} ;     
        rcs->testsetstruct(d);  
    }      
    
}
    void TEST1::testcallback(char * topic, byte * payload, uint16_t length)
    {
       B4R::B4RTEST1::testcallback(topic, payload, length);
    };
   //      rcs->SerialPrint("***Activities****");rcs->SerialPrint(String(raw));